// Code generated by sqlc. DO NOT EDIT.

package queries

import (
	"context"
	"database/sql"
	"fmt"
)

type DBTX interface {
	ExecContext(context.Context, string, ...interface{}) (sql.Result, error)
	PrepareContext(context.Context, string) (*sql.Stmt, error)
	QueryContext(context.Context, string, ...interface{}) (*sql.Rows, error)
	QueryRowContext(context.Context, string, ...interface{}) *sql.Row
}

func New(db DBTX) *Queries {
	return &Queries{db: db}
}

func Prepare(ctx context.Context, db DBTX) (*Queries, error) {
	q := Queries{db: db}
	var err error
	if q.createPersoonStmt, err = db.PrepareContext(ctx, createPersoon); err != nil {
		return nil, fmt.Errorf("error preparing query CreatePersoon: %w", err)
	}
	if q.deletePersoonStmt, err = db.PrepareContext(ctx, deletePersoon); err != nil {
		return nil, fmt.Errorf("error preparing query DeletePersoon: %w", err)
	}
	if q.deregisterPersoonStmt, err = db.PrepareContext(ctx, deregisterPersoon); err != nil {
		return nil, fmt.Errorf("error preparing query DeregisterPersoon: %w", err)
	}
	if q.getPersoonStmt, err = db.PrepareContext(ctx, getPersoon); err != nil {
		return nil, fmt.Errorf("error preparing query GetPersoon: %w", err)
	}
	if q.getPersoonByBsnStmt, err = db.PrepareContext(ctx, getPersoonByBsn); err != nil {
		return nil, fmt.Errorf("error preparing query GetPersoonByBsn: %w", err)
	}
	if q.listPersonenStmt, err = db.PrepareContext(ctx, listPersonen); err != nil {
		return nil, fmt.Errorf("error preparing query ListPersonen: %w", err)
	}
	if q.registerPersoonStmt, err = db.PrepareContext(ctx, registerPersoon); err != nil {
		return nil, fmt.Errorf("error preparing query RegisterPersoon: %w", err)
	}
	if q.updatePersoonStmt, err = db.PrepareContext(ctx, updatePersoon); err != nil {
		return nil, fmt.Errorf("error preparing query UpdatePersoon: %w", err)
	}
	return &q, nil
}

func (q *Queries) Close() error {
	var err error
	if q.createPersoonStmt != nil {
		if cerr := q.createPersoonStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing createPersoonStmt: %w", cerr)
		}
	}
	if q.deletePersoonStmt != nil {
		if cerr := q.deletePersoonStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing deletePersoonStmt: %w", cerr)
		}
	}
	if q.deregisterPersoonStmt != nil {
		if cerr := q.deregisterPersoonStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing deregisterPersoonStmt: %w", cerr)
		}
	}
	if q.getPersoonStmt != nil {
		if cerr := q.getPersoonStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing getPersoonStmt: %w", cerr)
		}
	}
	if q.getPersoonByBsnStmt != nil {
		if cerr := q.getPersoonByBsnStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing getPersoonByBsnStmt: %w", cerr)
		}
	}
	if q.listPersonenStmt != nil {
		if cerr := q.listPersonenStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing listPersonenStmt: %w", cerr)
		}
	}
	if q.registerPersoonStmt != nil {
		if cerr := q.registerPersoonStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing registerPersoonStmt: %w", cerr)
		}
	}
	if q.updatePersoonStmt != nil {
		if cerr := q.updatePersoonStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing updatePersoonStmt: %w", cerr)
		}
	}
	return err
}

func (q *Queries) exec(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) (sql.Result, error) {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).ExecContext(ctx, args...)
	case stmt != nil:
		return stmt.ExecContext(ctx, args...)
	default:
		return q.db.ExecContext(ctx, query, args...)
	}
}

func (q *Queries) query(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) (*sql.Rows, error) {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).QueryContext(ctx, args...)
	case stmt != nil:
		return stmt.QueryContext(ctx, args...)
	default:
		return q.db.QueryContext(ctx, query, args...)
	}
}

func (q *Queries) queryRow(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) *sql.Row {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).QueryRowContext(ctx, args...)
	case stmt != nil:
		return stmt.QueryRowContext(ctx, args...)
	default:
		return q.db.QueryRowContext(ctx, query, args...)
	}
}

type Queries struct {
	db                    DBTX
	tx                    *sql.Tx
	createPersoonStmt     *sql.Stmt
	deletePersoonStmt     *sql.Stmt
	deregisterPersoonStmt *sql.Stmt
	getPersoonStmt        *sql.Stmt
	getPersoonByBsnStmt   *sql.Stmt
	listPersonenStmt      *sql.Stmt
	registerPersoonStmt   *sql.Stmt
	updatePersoonStmt     *sql.Stmt
}

func (q *Queries) WithTx(tx *sql.Tx) *Queries {
	return &Queries{
		db:                    tx,
		tx:                    tx,
		createPersoonStmt:     q.createPersoonStmt,
		deletePersoonStmt:     q.deletePersoonStmt,
		deregisterPersoonStmt: q.deregisterPersoonStmt,
		getPersoonStmt:        q.getPersoonStmt,
		getPersoonByBsnStmt:   q.getPersoonByBsnStmt,
		listPersonenStmt:      q.listPersonenStmt,
		registerPersoonStmt:   q.registerPersoonStmt,
		updatePersoonStmt:     q.updatePersoonStmt,
	}
}
